aboutsummaryrefslogtreecommitdiff
path: root/scripts
diff options
context:
space:
mode:
authorRob Landley <rob@landley.net>2019-09-06 21:22:50 -0500
committerRob Landley <rob@landley.net>2019-09-06 21:22:50 -0500
commit3356140fd2d6f15b119ca98b4d7ff969a764cee6 (patch)
tree68a4722ff1749fa42b06673526146dab97c53732 /scripts
parent7ea6dee59b5f7ee13fdd3f52e6ee99b17ad07647 (diff)
downloadtoybox-3356140fd2d6f15b119ca98b4d7ff969a764cee6.tar.gz
Add cross.sh to cross compile for one or more targets, and tweak make.sh to
produce different output names for different ${TARGET}s.
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/cross.sh53
-rwxr-xr-xscripts/make.sh2
2 files changed, 54 insertions, 1 deletions
diff --git a/scripts/cross.sh b/scripts/cross.sh
new file mode 100755
index 00000000..44bd876e
--- /dev/null
+++ b/scripts/cross.sh
@@ -0,0 +1,53 @@
+#!/bin/bash
+
+# Convenience wrapper to set $CROSS_COMPILE from short name using "ccc"
+# symlink (Cross C Compiler) to a directory of cross compilers named
+# $TARGET-*-cross. Tested with scripts/mcm-buildall.sh output.
+
+# Usage: ./cross.sh $TARGET make distclean defconfig toybox
+# With no arguments, lists available targets. Use target "all" to iterate
+# through each $TARGET from the list.
+
+CCC="$(dirname "$(readlink -f "$0")")"/ccc
+if [ ! -d "$CCC" ]
+then
+ echo "Create symlink 'ccc' to cross compiler directory"
+ exit 1
+fi
+
+unset X Y
+
+# Display target list?
+list()
+{
+ ls "$CCC" | sed 's/-.*//' | sort -u | xargs
+}
+[ $# -eq 0 ] && list && exit
+
+X="$1"
+shift
+
+# build all targets?
+if [ "$X" == all ]
+then
+ for TARGET in $(list)
+ do
+ mkdir -p output/$TARGET
+ {
+ export TARGET
+ "$0" $TARGET "$@" 2>&1 || mv output/$TARGET{,.failed}
+ } | tee output/$TARGET/log.txt
+ done
+
+ exit
+fi
+
+# Call command with CROSS_COMPILE= as its first argument
+
+Y=$(readlink -f "$CCC"/$X-*cross)
+X=$(basename "$Y")
+export TARGET="${X/-*/}"
+X="$Y/bin/${X/-cross/-}"
+[ ! -e "${X}cc" ] && echo "${X}cc not found" && exit 1
+
+CROSS_COMPILE="$X" "$@"
diff --git a/scripts/make.sh b/scripts/make.sh
index 540199b6..ec908ce1 100755
--- a/scripts/make.sh
+++ b/scripts/make.sh
@@ -15,7 +15,7 @@ set -o pipefail
source scripts/portability.sh
[ -z "$KCONFIG_CONFIG" ] && KCONFIG_CONFIG=.config
-[ -z "$OUTNAME" ] && OUTNAME=toybox
+[ -z "$OUTNAME" ] && OUTNAME=toybox"${TARGET:+-$TARGET}"
UNSTRIPPED="generated/unstripped/$(basename "$OUTNAME")"
# Try to keep one more cc invocation going than we have processors